import java.io.File;
import java.io.FileFilter;
import java.util.Calendar;
import java.util.Locale;

import com.cs.util.LicenseUtil;
import com.spire.xls.CellStyle;
import com.spire.xls.FileFormat;
import com.spire.xls.PageSetup;
import com.spire.xls.Workbook;
import com.spire.xls.Worksheet;

public class ExcelToPdf {

    public static void main(String[] args) {
        
        System.out.println("----------------START-------------------");
        convertExcelToPdf();
        System.out.println("-----------------END------------------");
    }
    
    public static void convertExcelToPdf() {
    	
    	String parentPath = "E:\\test";
        String outputPath = "E:\\test\\pdf";
        String outputFileName = "";
        String outputFileFormat = "pdf";
        
        File[] files = new File(parentPath).listFiles(new FileFilter() {

            @Override
            public boolean accept(File pathname) {
                if (pathname.getName().endsWith(".xlsx") || pathname.getName().endsWith(".xls")) {
                    return true;
                }
                return false;
            }
        });
        
        Locale locale = new Locale("zh", "CN");
        Locale.setDefault(locale);
        
        for (File file : files) {
	            
			outputFileName = getOutputPath(outputPath + "\\" + file.getName(), outputFileFormat);
			System.out.println("In progress file ::: "+file.getName());
			System.out.println(Calendar.getInstance().getTime());
			
			Workbook workbook = new Workbook();
			workbook.loadFromFile(file.getPath());
			workbook.getConverterSetting().setSheetFitToWidth(true);
			workbook.getConverterSetting().isReCalculateOnConvert(false);
			
			for (int i = 0; i < workbook.getWorksheets().size(); i++) {
				
				//If the sheet doesn't include pivot table, calculating the value of sheet
				Worksheet worksheet = workbook.getWorksheets().get(i);
				
				if (worksheet.getPivotTables().getCount() == 0) {
					worksheet.CalculateAllValue();
				}
				
				for (int col = worksheet.getFirstColumn(); col <= worksheet.getLastColumn(); col++){
					CellStyle style = worksheet.getColumns()[col-1].getCellStyle();
					style.setShrinkToFit(true);
					style.setWrapText(false);
				}
				PageSetup pageSetup = worksheet.getPageSetup();
				pageSetup.setPrintArea(null);
			}
			workbook.saveToFile(outputFileName, FileFormat.PDF);
			workbook.dispose();
			System.out.println("Processed file ::: "+file.getName());
			System.out.println(Calendar.getInstance().getTime());
	    }
    }
    
    // To form pdf file name from excel file
    public static String getOutputPath(String sourcePath, String fileFormat) {
    	
        int index = sourcePath.lastIndexOf(".");
        String path = sourcePath.substring(0, ++index);
        return path + fileFormat;
    }
}
